#pragma once

#include "NPMessageHandler.h"
#include "Resource.h"

class CTrayIcon;

const UINT WM_TRAYICON_CALLBACK_MESSAGE = (WM_USER+1125);

namespace tipupdater
{
	class UpdaterConfigModel;
};

class TrayIconHandler : public CNMessageHandler
{
private:
	TrayIconHandler();
	~TrayIconHandler();

public:
	static TrayIconHandler *CreateInstacne();
	static void DestroyInstance();

	void SetUpdaterConfigModel( tipupdater::UpdaterConfigModel *configModel );
public:
	DECLARE_WND_CLASS(_T("TrayIconHandler")) 

	BEGIN_MSG_MAP(TrayIconHandler)
		MESSAGE_HANDLER(WM_TRAYICON_CALLBACK_MESSAGE, OnTrayIconCallback)
		COMMAND_ID_HANDLER( ID_SHOW_CONFIG, OnShowConfig )
		COMMAND_ID_HANDLER( ID_QUIT_NTOOLSUPDATER, OnQuit )
//		COMMAND_ID_HANDLER( ID_SHOW_NTOOLSUPDATER, OnViewOpen )
		COMMAND_ID_HANDLER( ID_HIDE_TRAYICON, OnHide )
	END_MSG_MAP()

	BOOL _Show();
	void _Hide();
	BOOL Restart();
	BOOL TryShow();
	void TryHide();
	BOOL IsShow();
	BOOL IsUpdating();

	void ShowTooltip(const TCHAR *text);
	void SetUpdatingToolTip();
	void SetEmptyToolTip();

	LRESULT OnTrayIconCallback(UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnShowConfig(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled);
	LRESULT OnViewOpen(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled);
	LRESULT OnQuit(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled);
	LRESULT OnHide(WORD w1, WORD w2, HWND hWnd, BOOL& bHandled);
	
	CTrayIcon* GetTrayIcon() { return m_TrayIcon; }
private:
	CTrayIcon				*m_TrayIcon;
	tipupdater::UpdaterConfigModel		*m_configModel;

private:
	static TrayIconHandler *m_TrayIconHandler;

public:
	static LPTOP_LEVEL_EXCEPTION_FILTER exception_filter;
};